#![feature(thread_sleep_until)]

use std::{thread::sleep_until, time::Instant};

fn main() {
    // It is necessary to call this function once. Otherwise some patches to the runtime
    // implemented by esp-idf-sys might not link properly. See https://github.com/esp-rs/esp-idf-template/issues/71
    esp_idf_svc::sys::link_patches();

    // Bind the log crate to the ESP Logging facilities
    esp_idf_svc::log::EspLogger::initialize_default();

    loop {
        log::info!("Hello, world!");

        // 睡眠一秒
        sleep_until(Instant::now() + std::time::Duration::from_secs(1));
    }
}
